---
updatedAt: 2026-05-01T13:51:43.000Z
agentTools:
  projectIndex: https://docs.censys.com/llms.txt
---

# Get DNS names that resolved to an IP (ranges)

Retrieve the domain names that resolved to an IP during a time frame. You can narrow results with `record_types` (A or AAAA).<br><br>Record results are broken down based on time range. For example, if `censys.com` resolved to `1.1.1.1` from January 1 to January 7 during two different ranges of January 1 to January 3 and January 5 to January 7, and you targeted January 1 through January 7 with your API call, then this endpoint will return one row for each of those distinct ranges.<br><br>To retrieve domain names for an IP with each result aggregated by name, use the [bounds endpoint endpoint](https://docs.censys.com/reference/v3-globaldata-dns-ip-resolution-bound).<br><br>This endpoint is only available to organizations on the Censys Search and Censys Core plans.<br><br>[Learn more about Censys Active DNS](https://docs.censys.com/docs/platform-active-dns).

# OpenAPI definition

```json
{
  "components": {
    "schemas": {
      "AuthenticationError": {
        "additionalProperties": false,
        "properties": {
          "error": {
            "$ref": "#/components/schemas/AuthenticationErrorDetail",
            "description": "Detailed information about the authentication error"
          }
        },
        "type": "object"
      },
      "AuthenticationErrorDetail": {
        "additionalProperties": false,
        "properties": {
          "code": {
            "description": "HTTP status code",
            "examples": [
              401
            ],
            "format": "int64",
            "type": "integer"
          },
          "message": {
            "description": "Human-readable message describing the error occurrence",
            "examples": [
              "Access credentials are invalid"
            ],
            "type": "string"
          },
          "reason": {
            "description": "Human-readable explanation of the underlying cause of the error",
            "examples": [
              "Access token is not active"
            ],
            "type": "string"
          },
          "request": {
            "type": "string"
          },
          "status": {
            "description": "HTTP status message associated with the error",
            "examples": [
              "Unauthorized"
            ],
            "type": "string"
          }
        },
        "type": "object"
      },
      "DnsIpResolutionRangeRecord": {
        "additionalProperties": false,
        "properties": {
          "domain": {
            "description": "The domain name that resolved to this IP.",
            "type": "string"
          },
          "first_seen": {
            "description": "The time this record was first observed.",
            "format": "date-time",
            "type": "string"
          },
          "last_seen": {
            "description": "The time this record was last observed.",
            "format": "date-time",
            "type": "string"
          },
          "record_type": {
            "description": "Either A or AAAA.",
            "enum": [
              "A",
              "AAAA"
            ],
            "type": "string"
          }
        },
        "required": [
          "domain",
          "first_seen",
          "last_seen",
          "record_type"
        ],
        "type": "object"
      },
      "DnsIpResolutionRangeResponse": {
        "additionalProperties": false,
        "properties": {
          "ip": {
            "description": "The IP address that was queried.",
            "type": "string"
          },
          "next_page_token": {
            "description": "A token that can be used to retrieve the next page of records.",
            "type": "string"
          },
          "records": {
            "description": "The list of domain names that resolved to this IP.",
            "items": {
              "$ref": "#/components/schemas/DnsIpResolutionRangeRecord"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "total_records": {
            "description": "The number of records that exist in total across all pages.",
            "format": "int64",
            "type": "integer"
          }
        },
        "required": [
          "ip",
          "next_page_token",
          "records",
          "total_records"
        ],
        "type": "object"
      },
      "ErrorDetail": {
        "additionalProperties": false,
        "properties": {
          "location": {
            "description": "Where the error occurred, e.g. 'body.items[3].tags' or 'path.thing-id'",
            "type": "string"
          },
          "message": {
            "description": "Error message text",
            "type": "string"
          },
          "value": {
            "description": "The value at the given location"
          }
        },
        "type": "object"
      },
      "ErrorModel": {
        "additionalProperties": false,
        "properties": {
          "detail": {
            "description": "A human-readable explanation specific to this occurrence of the problem.",
            "examples": [
              "Property foo is required but is missing."
            ],
            "type": "string"
          },
          "errors": {
            "description": "Optional list of individual error details",
            "items": {
              "$ref": "#/components/schemas/ErrorDetail"
            },
            "type": [
              "array",
              "null"
            ]
          },
          "instance": {
            "description": "A URI reference that identifies the specific occurrence of the problem.",
            "examples": [
              "https://example.com/error-log/abc123"
            ],
            "format": "uri",
            "type": "string"
          },
          "status": {
            "description": "HTTP status code",
            "examples": [
              400
            ],
            "format": "int64",
            "type": "integer"
          },
          "title": {
            "description": "A short, human-readable summary of the problem type. This value should not change between occurrences of the error.",
            "examples": [
              "Bad Request"
            ],
            "type": "string"
          },
          "type": {
            "default": "about:blank",
            "description": "A URI reference to human-readable documentation for the error.",
            "examples": [
              "https://example.com/errors/example"
            ],
            "format": "uri",
            "type": "string"
          }
        },
        "type": "object"
      },
      "ResponseEnvelopeDnsIpResolutionRangeResponse": {
        "additionalProperties": false,
        "properties": {
          "result": {
            "$ref": "#/components/schemas/DnsIpResolutionRangeResponse"
          }
        },
        "type": "object"
      }
    },
    "securitySchemes": {
      "PersonalAccessToken": {
        "description": "Your Censys personal access token. These are managed in your [Account Settings](https://accounts.censys.io/settings/personal-access-tokens)",
        "scheme": "bearer",
        "type": "http"
      }
    }
  },
  "info": {
    "contact": {
      "email": "support@censys.com",
      "name": "Censys Inc.",
      "url": "https://censys.com"
    },
    "title": "Censys Platform API",
    "version": "1.0.151"
  },
  "openapi": "3.1.0",
  "paths": {
    "/v3/global/dns/resolutions/ip/{ip}/ranges": {
      "get": {
        "description": "Retrieve the domain names that resolved to an IP during a time frame. You can narrow results with `record_types` (A or AAAA).<br><br>Record results are broken down based on time range. For example, if `censys.com` resolved to `1.1.1.1` from January 1 to January 7 during two different ranges of January 1 to January 3 and January 5 to January 7, and you targeted January 1 through January 7 with your API call, then this endpoint will return one row for each of those distinct ranges.<br><br>To retrieve domain names for an IP with each result aggregated by name, use the [bounds endpoint endpoint](https://docs.censys.com/reference/v3-globaldata-dns-ip-resolution-bound).<br><br>This endpoint is only available to organizations on the Censys Search and Censys Core plans.<br><br>[Learn more about Censys Active DNS](https://docs.censys.com/docs/platform-active-dns).",
        "operationId": "v3-globaldata-dns-ip-resolution-ranges",
        "parameters": [
          {
            "description": "The ID of a Censys organization to associate the request with. See the [Getting Started docs](https://docs.censys.com/reference/get-started#step-3-find-and-use-your-organization-id-optional) for more information.",
            "explode": false,
            "in": "query",
            "name": "organization_id",
            "required": true,
            "schema": {
              "description": "The ID of a Censys organization to associate the request with. See the [Getting Started docs](https://docs.censys.com/reference/get-started#step-3-find-and-use-your-organization-id-optional) for more information.",
              "examples": [
                "11111111-2222-3333-4444-555555555555"
              ],
              "format": "uuid",
              "type": "string"
            }
          },
          {
            "description": "The ID of a Censys organization to associate the request with. See the [Getting Started docs](https://docs.censys.com/reference/get-started#step-3-find-and-use-your-organization-id-optional) for more information. Note: The header parameter is supported for atypical use cases; we recommend always providing this field via the query parameter.",
            "in": "header",
            "name": "X-Organization-ID",
            "schema": {
              "description": "The ID of a Censys organization to associate the request with. See the [Getting Started docs](https://docs.censys.com/reference/get-started#step-3-find-and-use-your-organization-id-optional) for more information. Note: The header parameter is supported for atypical use cases; we recommend always providing this field via the query parameter.",
              "examples": [
                "11111111-2222-3333-4444-555555555555"
              ],
              "format": "uuid",
              "type": "string"
            },
            "x-speakeasy-ignore": true
          },
          {
            "description": "Start of date range (RFC3339 format, e.g., 2024-01-01T00:00:00Z). If not specified, defaults to the maximum query window back from the end time.",
            "explode": false,
            "in": "query",
            "name": "start_time",
            "schema": {
              "description": "Start of date range (RFC3339 format, e.g., 2024-01-01T00:00:00Z). If not specified, defaults to the maximum query window back from the end time.",
              "examples": [
                "2024-01-01T00:00:00Z"
              ],
              "type": "string"
            }
          },
          {
            "description": "End of date range (RFC3339 format, e.g., 2024-01-31T23:59:59Z). If not specified, defaults to now. Cannot be in the future.",
            "explode": false,
            "in": "query",
            "name": "end_time",
            "schema": {
              "description": "End of date range (RFC3339 format, e.g., 2024-01-31T23:59:59Z). If not specified, defaults to now. Cannot be in the future.",
              "examples": [
                "2024-01-31T23:59:59Z"
              ],
              "type": "string"
            }
          },
          {
            "description": "Number of results per page (max 100)",
            "explode": false,
            "in": "query",
            "name": "page_size",
            "schema": {
              "default": 100,
              "description": "Number of results per page (max 100)",
              "examples": [
                50
              ],
              "format": "int32",
              "maximum": 100,
              "minimum": 1,
              "type": "integer"
            }
          },
          {
            "description": "Pagination token from previous response",
            "explode": false,
            "in": "query",
            "name": "page_token",
            "schema": {
              "description": "Pagination token from previous response",
              "type": "string"
            }
          },
          {
            "description": "Filter by record types (A, AAAA). For multiple values, include comma-separated values. Defaults to A and AAAA when omitted.",
            "explode": false,
            "in": "query",
            "name": "record_types",
            "schema": {
              "description": "Filter by record types (A, AAAA). For multiple values, include comma-separated values. Defaults to A and AAAA when omitted.",
              "examples": [
                [
                  "A"
                ]
              ],
              "items": {
                "enum": [
                  "A",
                  "AAAA"
                ],
                "type": "string"
              },
              "type": [
                "array",
                "null"
              ]
            }
          },
          {
            "description": "Filter to a specific domain name resolving to this IP.",
            "explode": false,
            "in": "query",
            "name": "domain",
            "schema": {
              "description": "Filter to a specific domain name resolving to this IP.",
              "examples": [
                "platform.censys.io"
              ],
              "type": "string"
            }
          },
          {
            "description": "The IP address of a DNS record.",
            "in": "path",
            "name": "ip",
            "required": true,
            "schema": {
              "description": "The IP address of a DNS record.",
              "examples": [
                "8.8.8.8"
              ],
              "format": "ip",
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ResponseEnvelopeDnsIpResolutionRangeResponse"
                }
              }
            },
            "description": "A list of domain names that resolved to the provided IP.",
            "headers": {
              "Content-Type": {
                "schema": {
                  "type": "string"
                }
              },
              "X-Request-ID": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "content": {
              "application/problem+json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorModel"
                }
              }
            },
            "description": "Bad request"
          },
          "401": {
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/AuthenticationError"
                }
              }
            },
            "description": "Request does not contain a valid Authorization token"
          },
          "403": {
            "content": {
              "application/problem+json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorModel"
                }
              }
            },
            "description": "User does not have permission to access this data"
          },
          "404": {
            "content": {
              "application/problem+json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorModel"
                }
              }
            },
            "description": "Resource not found"
          },
          "409": {
            "content": {
              "application/problem+json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorModel"
                }
              }
            },
            "description": "Feature not enabled"
          },
          "500": {
            "content": {
              "application/problem+json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorModel"
                }
              }
            },
            "description": "Internal server error"
          }
        },
        "security": [
          {
            "PersonalAccessToken": []
          }
        ],
        "summary": "Get DNS names that resolved to an IP (ranges)",
        "tags": [
          "Global Data"
        ],
        "x-speakeasy-name-override": "ListDnsIpResolutionRanges"
      }
    }
  },
  "servers": [
    {
      "description": "The Censys Platform API",
      "url": "https://api.platform.censys.io"
    }
  ],
  "tags": [
    {
      "description": "Endpoints related to the Global Data product",
      "name": "Global Data"
    }
  ],
  "x-readme": {
    "parameter-ordering": [
      "path",
      "body",
      "query",
      "cookie",
      "form",
      "header"
    ],
    "samples-languages": [
      "shell",
      "python",
      "go",
      "javascript",
      "java"
    ]
  },
  "x-speakeasy-globals": {
    "parameters": [
      {
        "in": "query",
        "name": "organization_id",
        "schema": {
          "type": "string"
        }
      }
    ]
  }
}
```